<?php
/*
* $Id: swc_hooks.php
* $Loc: /templates/override/includes/hooks/shop/siteWide/
*
* Name: SloppyWordsCleaner
* Version: 3.4.4
* Release Date: 2024-06-02
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under the GNU General Public License
*
* Comments: Author: [Rainer Schmied @raiwa]
* Author URI: [www.phoenixcartaddons.com]
* 
* CE Phoenix, E-Commerce made Easy
* https://phoenixcart.org
* 
* Copyright (c) 2021 Phoenix Cart
* 
* 
*/

class hook_shop_siteWide_swc_hooks {
  
  var $exceptions;
  var $all_lowercase;
  var $all_uppercase;
  var $prefixes;
  var $suffixes;
  var $word;
  var $csmod;

  function listen_injectFormVerify() {
    global $customer_details;
    global $customers_firstname, $customers_lastname, $ship_firstname, $ship_lastname, $ship_address, $ship_postcode, $ship_city, $ship_zone; // PayPal
    if ( defined('MODULE_STORE_SWCLEANER_STATUS') && MODULE_STORE_SWCLEANER_STATUS == 'True' && !Text::is_empty(MODULE_STORE_SWCLEANER_PAGES) ) {
      $pages_array = [];

      foreach (explode(';', MODULE_STORE_SWCLEANER_PAGES) as $page) {
        $page = trim($page);

        if (!empty($page)) {
          $pages_array[] = $page;
        }
      }
 
      if ( in_array(Request::get_page(), $pages_array) ) {
        if (isset($customer_details['firstname'])) $customer_details['firstname'] = $this->RemoveShouting($customer_details['firstname']);
        if (isset($customer_details['lastname'])) $customer_details['lastname'] = $this->RemoveShouting($customer_details['lastname'],'name');
        if (isset($customer_details['email_address'])) $customer_details['email_address'] = strtolower($customer_details['email_address']);
        if (isset($customer_details['company']) && MODULE_STORE_SWCLEANER_CLEAN_COMPANY == 'True') $customer_details['company'] = RemoveShouting($customer_details['company'], 'company');
        if (isset($customer_details['nif'])) $customer_details['nif'] = strtoupper($customer_details['nif']);
        if (isset($customer_details['entry_ein'])) $customer_details['entry_ein'] = strtoupper($customer_details['entry_ein']);
        if (isset($customer_details['piva'])) $customer_details['piva'] = strtoupper($customer_details['piva']);
        if (isset($customer_details['cf'])) $customer_details['cf'] = strtoupper($customer_details['cf']);
        if (isset($customer_details['street_address'])) $customer_details['street_address'] = $this->RemoveShouting($customer_details['street_address'],'address');
        if (isset($customer_details['street_address2'])) $customer_details['street_address2'] = $this->RemoveShouting($customer_details['street_address2'],'address');
        if (isset($customer_details['suburb'])) $customer_details['suburb'] = $this->RemoveShouting($customer_details['suburb']);
        if (isset($customer_details['postcode'])) $customer_details['postcode'] = strtoupper($customer_details['postcode']);
        if (isset($customer_details['city'])) $customer_details['city'] = $this->RemoveShouting($customer_details['city']);
        if (isset($customer_details['entry_state'])) $customer_details['entry_state'] = $this->RemoveShouting($customer_details['entry_state']);
        // PayPal express retrieve PayPal account data support
        if (isset($customers_firstname)) $customers_firstname = $this->RemoveShouting($customers_firstname);
        if (isset($customers_lastname)) $customers_lastname = $this->RemoveShouting($customers_lastname,'name');
        if (isset($ship_firstname)) $ship_firstname = $this->RemoveShouting($ship_firstname);
        if (isset($ship_lastname)) $ship_lastname = $this->RemoveShouting($ship_lastname,'name');
        if (isset($ship_address)) $ship_address = $this->RemoveShouting($ship_address,'address');
        if (isset($ship_postcode)) $ship_postcode = strtoupper($ship_postcode);
        if (isset($ship_city)) $ship_city = $this->RemoveShouting($ship_city);
        if (isset($ship_zone)) $ship_zone = $this->RemoveShouting($ship_zone);
      } // end if page in array
    } // end if MODULE_STORE_SWCLEANER_STATUS
  } // End SwcCreateAccountMod
  
  
    
  protected function RemoveShouting($string, $mode = '') {
    
    (defined('CHARSET') && CHARSET == 'utf-8')? $this->csmod = 'u' : '' ;

    // captialize all first letters
    $str = mb_convert_case($string, MB_CASE_TITLE, CHARSET);
    
    // exceptions
    $this->exceptions = explode(',', MODULE_STORE_SWCLEANER_EXCEPTIONS);
    
    // exceptions to standard case conversion
    switch ($mode) {
      case 'name':
        $this->all_lowercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_LOWER_NAME);
        $this->all_uppercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_UPPER_NAME);
        $this->prefixes = str_replace(',', '|', MODULE_STORE_SWCLEANER_PREFIXES) . '|&nbsp;';
        break; 
      case 'company':
        $this->all_lowercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_LOWER_COMPANY);
        $this->all_uppercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_UPPER_COMPANY);
        $this->prefixes = NULL;
        break; 
      case 'address':
        $this->all_lowercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_LOWER_NAME);
        $this->all_uppercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_UPPER);
        $this->prefixes = str_replace(',', '|', MODULE_STORE_SWCLEANER_PREFIXES) . '|&nbsp;';
        break; 
      default:
        $this->all_lowercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_LOWER);
        $this->all_uppercase = str_replace(',', '|', MODULE_STORE_SWCLEANER_ALL_UPPER);
        $this->prefixes = str_replace(',', '|', MODULE_STORE_SWCLEANER_PREFIXES) . '|&nbsp;';
    }
  
    $this->suffixes = str_replace(',', '|', MODULE_STORE_SWCLEANER_SUFFIXES);

    // target words
    $this->word = [MODULE_STORE_SWCLEANER_CONVERT_PAIRS];

    // do only things if string is not clean and nothing in lists
    if ( ($string != $str || preg_match("#( . $this->all_lowercase . )#", $string) || preg_match("#( . $this->all_uppercase . )#", $string)) && !in_array($string, $this->exceptions) || MODULE_STORE_SWCLEANER_REMOVE_SPECIALS == 'True' ) { 
      
      // BEGIN cleaning
     
      // capitalize acronymns and initialisms i.e. PO
      if ($this->all_uppercase) {
        $str = $this->conv_to_upper($str);
      }

      // capitalize letter after certain name prefixes i.e. 'Mc'
      if ($this->prefixes) {
        $str = $this->conv_prefixes($str);
      }
     
      if ($this->all_lowercase) {
        // decapitalize short words i.e. and
        if ( $mode == 'name' || $mode == 'address' ) {
          // all occurences will be changed to lowercase
          $str = $this->conv_to_lower_name($str);
        } else {
          // first and last word will not be changed to lower case (i.e. titles)
          $str = $this->conv_to_lower($str);
        }
      }
      
      // decapitalize certain word suffixes i.e. 's
      if ($this->suffixes) {
        $str = $this->conv_suffixes($str);
      }
      
      // replace target words after RemoveShouting
      if ($this->word) {
        $str = $this->replace_word($str);
      }

      // remove specials
      if (MODULE_STORE_SWCLEANER_REMOVE_SPECIALS == 'True') {
        $str = $this->remove_specials($str);
      }
      
      // return cleaned string
      return $str;

    } else {
      
      // return original string
      return $string;
    }      
  }

  protected function conv_to_upper($str) {
     $str = preg_replace_callback(
             "/\\b($this->all_uppercase)\\b/" . $this->csmod,
             function ($m) {
               return mb_convert_case($m[1], MB_CASE_UPPER, CHARSET);
             },
             $str
             );
    
    return $str;
  }

  protected function conv_to_lower_name($str) {
      $str = preg_replace_callback(
             "/\\b($this->all_lowercase)\\b/i" . $this->csmod,
             function ($m) {
                return mb_convert_case($m[1], MB_CASE_LOWER, CHARSET);
             },
             $str
             );   
    
    return $str;
  }

  protected function conv_to_lower($str) {
      $str = preg_replace_callback(
             "/(?<=\\W)($this->all_lowercase)(?=\\W)/i" . $this->csmod,
             function ($m) {
               return mb_convert_case($m[1], MB_CASE_LOWER, CHARSET);
             },
             $str
             );   
    
    return $str;
  }

  protected function conv_prefixes($str) {
     $str = preg_replace_callback(
            "/\\b($this->prefixes |)(\\w)/" . $this->csmod,
            function ($m) {
              return $m[1] . mb_convert_case($m[2], MB_CASE_UPPER, CHARSET);
            },
            $str
            );   
    
    return $str;
  }

  protected function conv_suffixes($str) {
    $str = preg_replace_callback(
            "/(\\w)($this->suffixes)\\b/" . $this->csmod,
            function ($m) {
              return $m[1] . mb_convert_case(stripslashes($m[2]), MB_CASE_LOWER, CHARSET);
            },
            $str
            );   
    
    return $str;
  }

  protected function replace_word($str) {
    if(!function_exists('explode_by_comma')) {
      function explode_by_comma ($_) {
        return explode (':', $_);
      }
    }
    $this->word = array_map('explode_by_comma', explode (',', MODULE_STORE_SWCLEANER_CONVERT_PAIRS));

    for ($i=0, $n=sizeof($this->word); $i<$n; $i++) {
      $str = preg_replace('/' . $this->word[$i][0] . '/', $this->word[$i][1], $str);
    }
 
    return $str;
  }

  /**
   * Converts all accent characters to ASCII characters.
   *
   * If there are no accent characters, then the string given is just returned.
   *
   * @param string $string Text that might have accent characters
   * @return string Filtered string with replaced "nice" characters.
   */
  function remove_specials($string) {
    
    if ( !preg_match('/[\x80-\xff]/', $string) )
        return $string;

    $chars = [
    // Decompositions for Latin-1 Supplement
    chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
    chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
    chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
    chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
    chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
    chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
    chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
    chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
    chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
    chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
    chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
    chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
    chr(195).chr(156) => 'U', chr(195).chr(157) => 'Y',
    chr(195).chr(159) => 's', chr(195).chr(160) => 'a',
    chr(195).chr(161) => 'a', chr(195).chr(162) => 'a',
    chr(195).chr(163) => 'a', chr(195).chr(164) => 'a',
    chr(195).chr(165) => 'a', chr(195).chr(167) => 'c',
    chr(195).chr(168) => 'e', chr(195).chr(169) => 'e',
    chr(195).chr(170) => 'e', chr(195).chr(171) => 'e',
    chr(195).chr(172) => 'i', chr(195).chr(173) => 'i',
    chr(195).chr(174) => 'i', chr(195).chr(175) => 'i',
    chr(195).chr(177) => 'n', chr(195).chr(178) => 'o',
    chr(195).chr(179) => 'o', chr(195).chr(180) => 'o',
    chr(195).chr(181) => 'o', chr(195).chr(182) => 'o',
    chr(195).chr(182) => 'o', chr(195).chr(185) => 'u',
    chr(195).chr(186) => 'u', chr(195).chr(187) => 'u',
    chr(195).chr(188) => 'u', chr(195).chr(189) => 'y',
    chr(195).chr(191) => 'y',
    // Decompositions for Latin Extended-A
    chr(196).chr(128) => 'A', chr(196).chr(129) => 'a',
    chr(196).chr(130) => 'A', chr(196).chr(131) => 'a',
    chr(196).chr(132) => 'A', chr(196).chr(133) => 'a',
    chr(196).chr(134) => 'C', chr(196).chr(135) => 'c',
    chr(196).chr(136) => 'C', chr(196).chr(137) => 'c',
    chr(196).chr(138) => 'C', chr(196).chr(139) => 'c',
    chr(196).chr(140) => 'C', chr(196).chr(141) => 'c',
    chr(196).chr(142) => 'D', chr(196).chr(143) => 'd',
    chr(196).chr(144) => 'D', chr(196).chr(145) => 'd',
    chr(196).chr(146) => 'E', chr(196).chr(147) => 'e',
    chr(196).chr(148) => 'E', chr(196).chr(149) => 'e',
    chr(196).chr(150) => 'E', chr(196).chr(151) => 'e',
    chr(196).chr(152) => 'E', chr(196).chr(153) => 'e',
    chr(196).chr(154) => 'E', chr(196).chr(155) => 'e',
    chr(196).chr(156) => 'G', chr(196).chr(157) => 'g',
    chr(196).chr(158) => 'G', chr(196).chr(159) => 'g',
    chr(196).chr(160) => 'G', chr(196).chr(161) => 'g',
    chr(196).chr(162) => 'G', chr(196).chr(163) => 'g',
    chr(196).chr(164) => 'H', chr(196).chr(165) => 'h',
    chr(196).chr(166) => 'H', chr(196).chr(167) => 'h',
    chr(196).chr(168) => 'I', chr(196).chr(169) => 'i',
    chr(196).chr(170) => 'I', chr(196).chr(171) => 'i',
    chr(196).chr(172) => 'I', chr(196).chr(173) => 'i',
    chr(196).chr(174) => 'I', chr(196).chr(175) => 'i',
    chr(196).chr(176) => 'I', chr(196).chr(177) => 'i',
    chr(196).chr(178) => 'IJ',chr(196).chr(179) => 'ij',
    chr(196).chr(180) => 'J', chr(196).chr(181) => 'j',
    chr(196).chr(182) => 'K', chr(196).chr(183) => 'k',
    chr(196).chr(184) => 'k', chr(196).chr(185) => 'L',
    chr(196).chr(186) => 'l', chr(196).chr(187) => 'L',
    chr(196).chr(188) => 'l', chr(196).chr(189) => 'L',
    chr(196).chr(190) => 'l', chr(196).chr(191) => 'L',
    chr(197).chr(128) => 'l', chr(197).chr(129) => 'L',
    chr(197).chr(130) => 'l', chr(197).chr(131) => 'N',
    chr(197).chr(132) => 'n', chr(197).chr(133) => 'N',
    chr(197).chr(134) => 'n', chr(197).chr(135) => 'N',
    chr(197).chr(136) => 'n', chr(197).chr(137) => 'N',
    chr(197).chr(138) => 'n', chr(197).chr(139) => 'N',
    chr(197).chr(140) => 'O', chr(197).chr(141) => 'o',
    chr(197).chr(142) => 'O', chr(197).chr(143) => 'o',
    chr(197).chr(144) => 'O', chr(197).chr(145) => 'o',
    chr(197).chr(146) => 'OE',chr(197).chr(147) => 'oe',
    chr(197).chr(148) => 'R',chr(197).chr(149) => 'r',
    chr(197).chr(150) => 'R',chr(197).chr(151) => 'r',
    chr(197).chr(152) => 'R',chr(197).chr(153) => 'r',
    chr(197).chr(154) => 'S',chr(197).chr(155) => 's',
    chr(197).chr(156) => 'S',chr(197).chr(157) => 's',
    chr(197).chr(158) => 'S',chr(197).chr(159) => 's',
    chr(197).chr(160) => 'S', chr(197).chr(161) => 's',
    chr(197).chr(162) => 'T', chr(197).chr(163) => 't',
    chr(197).chr(164) => 'T', chr(197).chr(165) => 't',
    chr(197).chr(166) => 'T', chr(197).chr(167) => 't',
    chr(197).chr(168) => 'U', chr(197).chr(169) => 'u',
    chr(197).chr(170) => 'U', chr(197).chr(171) => 'u',
    chr(197).chr(172) => 'U', chr(197).chr(173) => 'u',
    chr(197).chr(174) => 'U', chr(197).chr(175) => 'u',
    chr(197).chr(176) => 'U', chr(197).chr(177) => 'u',
    chr(197).chr(178) => 'U', chr(197).chr(179) => 'u',
    chr(197).chr(180) => 'W', chr(197).chr(181) => 'w',
    chr(197).chr(182) => 'Y', chr(197).chr(183) => 'y',
    chr(197).chr(184) => 'Y', chr(197).chr(185) => 'Z',
    chr(197).chr(186) => 'z', chr(197).chr(187) => 'Z',
    chr(197).chr(188) => 'z', chr(197).chr(189) => 'Z',
    chr(197).chr(190) => 'z', chr(197).chr(191) => 's',
    // Euro Sign
    chr(226).chr(130).chr(172) => 'E',
    // GBP (Pound) Sign
    chr(194).chr(163) => ''];

    $string = strtr($string, $chars);

    return $string;
  }
  
} // End class
